﻿// Copyright (c) Interactive Scientific LTD. All rights reserved.
// Licensed under the GPL. See License.txt in the project root for license information.
using Nano.Transport.Agents;
using Nano.Transport.Comms.ServerSocketImplementations;
using System;
using System.Net;
using System.Net.Sockets;
using Nano.Transport.Comms.Security;

namespace Nano.Transport.Comms
{
    /// <summary>
    /// Represents the session of a client within a server instance.
    /// </summary>
    /// <autogeneratedoc />
    internal class ClientSession : IServerSocketImplementation
    {
        private IServerSocketImplementation socketImplementation;

        /// <summary>
        /// Occurs when the session has ended.
        /// </summary>
        public event EventHandler Ended;

        /// <summary>
        /// Occurs when the session begins.
        /// </summary>
        public event EventHandler Started;

        /// <summary>
        /// The IP end point of the client.
        /// </summary>
        public IPEndPoint EndPoint => socketImplementation.EndPoint;

        public TransportSecuritySessionToken SessionToken { get; }

        /// <summary>
        /// Initializes a new instance of the <see cref="ClientSession"/> class.
        /// </summary>
        /// <param name="client">The client.</param>
        /// <param name="packetStatistics"></param>
        /// <param name="reporter">The reporter.</param>
        /// <param name="receiver">The receiver.</param>
        /// <exception cref="System.ArgumentNullException">
        /// client
        /// or
        /// reporter
        /// or
        /// receiver
        /// </exception>
        /// <autogeneratedoc />
        public ClientSession(
            ConnectionType connectionType, 
            TransportSecuritySessionToken token, 
            TcpClient client, 
            PacketStatistics packetStatistics, 
            IReporter reporter, 
            ITransportPacketReceiver receiver)
        {
            SessionToken = token;

            switch (connectionType)
            {
                case ConnectionType.Tcp:
                    socketImplementation = new TcpSocketImplementation(client, packetStatistics, reporter, receiver);
                    break;
                case ConnectionType.WebSocket:
                    socketImplementation = new WebSocketImplementation(token, client, packetStatistics, reporter, receiver);
                    break;
                default:
                    throw new ArgumentOutOfRangeException(nameof(connectionType), connectionType, null);
            }            

            socketImplementation.Started += SocketImplementation_Started;
            socketImplementation.Ended += SocketImplementation_Ended;
        }

        /// <summary>
        /// Performs application-defined tasks associated with freeing, releasing, or resetting resources.
        /// </summary>
        public void Dispose()
        {
            socketImplementation.Dispose();
        }

        /// <summary>
        /// Flushes the buffer is BufferOutput is <c>true</c>.
        /// </summary>
        /// <returns><c>true</c> if flush was successful, <c>false</c> otherwise.</returns>
        public bool Flush()
        {
            return socketImplementation.Flush();
        }

        /// <summary>
        /// Sends a packet using the specified priority.
        /// </summary>
        /// <param name="priority">The priority.</param>
        /// <param name="data">The data.</param>
        /// <param name="index">The index.</param>
        /// <param name="count">The count.</param>
        /// <returns><c>true</c> if the packet was queued; otherwise, <c>false</c>.</returns>
        /// <exception cref="System.ArgumentNullException">data</exception>
        /// <exception cref="System.ArgumentOutOfRangeException">
        /// index
        /// or
        /// count
        /// </exception>
        public bool Send(TransportPacketPriority priority, byte[] data, int index, int count)
        {
            return socketImplementation.Send(priority, data, index, count);
        }

        /// <summary>
        /// Starts this instance.
        /// </summary>
        public void Start()
        {
            socketImplementation.Start();
        }

        /// <summary>
        /// Stops this instance.
        /// </summary>
        public void Stop()
        {
            socketImplementation.Stop();
        }

        private void SocketImplementation_Ended(object sender, EventArgs e)
        {
            Ended?.Invoke(this, e);
        }

        private void SocketImplementation_Started(object sender, EventArgs e)
        {
            Started?.Invoke(this, e);
        }
    }
}